Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentArchiveView.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentArchiveView.cs	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentArchiveView.cs	(revision 7970)
@@ -101,5 +101,5 @@
       if (h.ChartElementType == ChartElementType.DataPoint) {
         var solution = (GQAPSolution)((DataPoint)h.Object).Tag;
-        var assignment = new GQAPAssignment(solution.Assignment, solution.Quality, solution.FlowDistanceQuality, solution.InstallationQuality, solution.OverbookedCapacity, Content.EquipmentNames, Content.LocationNames, Content.Distances, Content.Weights, Content.InstallationCosts, Content.Demands, Content.Capacities, Content.TransportationCosts, Content.OverbookedCapacityPenalty);
+        var assignment = new GQAPAssignment(solution.Assignment, solution.Quality, solution.FlowDistanceQuality, solution.InstallationQuality, solution.OverbookedCapacity, Content.EquipmentNames, Content.LocationNames, Content.Distances, Content.Weights, Content.InstallationCosts, Content.Demands, Content.Capacities, Content.TransportationCosts, Content.ExpectedRandomQuality, Content.Evaluator);
 
         var view = MainFormManager.MainForm.ShowContent(assignment);
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentView.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentView.cs	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment.Views/3.3/GQAPAssignmentView.cs	(revision 7970)
@@ -315,5 +315,5 @@
     private void recalculateButton_Click(object sender, EventArgs e) {
       double fdq, iq, oc;
-      GQAPEvaluator.Evaluate(Content.Assignment, Content.Weights,
+      Content.Evaluator.Evaluate(Content.Assignment, Content.Weights,
         Content.Distances, Content.InstallationCosts, Content.Demands,
         Content.Capacities, out fdq, out iq, out oc);
@@ -322,6 +322,6 @@
       Content.OverbookedCapacity = new DoubleValue(oc);
       Content.Quality = new DoubleValue(
-        GQAPEvaluator.GetCombinedQuality(fdq, iq, oc,
-        Content.TransportationCosts.Value, Content.OverbookedCapacityPenalty.Value));
+        Content.Evaluator.GetFitness(fdq, iq, oc,
+        Content.TransportationCosts.Value, Content.ExpectedRandomQuality.Value));
     }
   }
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Analyzers/BestGQAPSolutionAnalyzer.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Analyzers/BestGQAPSolutionAnalyzer.cs	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Analyzers/BestGQAPSolutionAnalyzer.cs	(revision 7970)
@@ -29,5 +29,4 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Problems.GeneralizedQuadraticAssignment.Common;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
@@ -40,6 +39,7 @@
     IQualitiesAwareGQAPOperator, IDistancesAwareGQAPOperator, IWeightsAwareGQAPOperator, IInstallationCostsAwareGQAPOperator,
     IDemandsAwareGQAPOperator, ICapacitiesAwareGQAPOperator, ITransportationCostsAwareGQAPOperator,
-    IOverbookedCapacityPenaltyAwareGQAPOperator, IEquipmentNamesAwareGQAPOperator, ILocationNamesAwareGQAPOperator,
-    IBestKnownQualityAwareGQAPOperator, IBestKnownSolutionAwareGQAPOperator, IAnalyzer {
+    IExpectedRandomQualityAwareGQAPOperator, IEquipmentNamesAwareGQAPOperator, ILocationNamesAwareGQAPOperator,
+    IBestKnownQualityAwareGQAPOperator, IBestKnownSolutionAwareGQAPOperator,
+    IEvaluatorAwareGQAPOperator, IAnalyzer {
 
     public bool EnabledByDefault {
@@ -84,6 +84,6 @@
       get { return (IValueLookupParameter<DoubleValue>)Parameters["TransportationCosts"]; }
     }
-    public IValueLookupParameter<DoubleValue> OverbookedCapacityPenaltyParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["OverbookedCapacityPenalty"]; }
+    public IValueLookupParameter<DoubleValue> ExpectedRandomQualityParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["ExpectedRandomQuality"]; }
     }
     public ILookupParameter<StringArray> EquipmentNamesParameter {
@@ -104,4 +104,7 @@
     public IValueLookupParameter<ResultCollection> ResultsParameter {
       get { return (IValueLookupParameter<ResultCollection>)Parameters["Results"]; }
+    }
+    public IValueLookupParameter<IGQAPEvaluator> EvaluatorParameter {
+      get { return (IValueLookupParameter<IGQAPEvaluator>)Parameters["Evaluator"]; }
     }
     #endregion
@@ -122,5 +125,5 @@
       Parameters.Add(new LookupParameter<DoubleArray>("Capacities", GeneralizedQuadraticAssignmentProblem.CapacitiesDescription));
       Parameters.Add(new ValueLookupParameter<DoubleValue>("TransportationCosts", GeneralizedQuadraticAssignmentProblem.TransportationCostsDescription));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("OverbookedCapacityPenalty", GeneralizedQuadraticAssignmentProblem.OverbookedCapacityPenaltyDescription));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("ExpectedRandomQuality", GeneralizedQuadraticAssignmentProblem.ExpectedRandomQualityDescription));
       Parameters.Add(new ScopeTreeLookupParameter<IntegerVector>("Assignment", GQAPSolutionCreator.AssignmentDescription));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", GQAPEvaluator.QualityDescription));
@@ -134,7 +137,9 @@
       Parameters.Add(new LookupParameter<GQAPAssignment>("BestSolution", "The best GQAP solution found so far."));
       Parameters.Add(new ValueLookupParameter<ResultCollection>("Results", "The result collection where the best GQAP solution should be stored."));
+      Parameters.Add(new ValueLookupParameter<IGQAPEvaluator>("Evaluator", "The evaluator that is used to evaluate GQAP solutions."));
     }
 
     public override IOperation Apply() {
+      var evaluator = EvaluatorParameter.ActualValue;
       var assignments = AssignmentParameter.ActualValue;
       var qualities = QualityParameter.ActualValue;
@@ -150,5 +155,5 @@
       var capacities = CapacitiesParameter.ActualValue;
       var transportationCosts = TransportationCostsParameter.ActualValue;
-      var overbookedCapacityPenalty = OverbookedCapacityPenaltyParameter.ActualValue;
+      var expectedRandomQuality = ExpectedRandomQualityParameter.ActualValue;
       var results = ResultsParameter.ActualValue;
       var maximization = MaximizationParameter.ActualValue.Value;
@@ -162,10 +167,10 @@
       if (bestKnownQuality == null || HasSolutionImproved(bestKnownQuality.Value, qualities[bestIndex].Value, maximization)) {
         BestKnownQualityParameter.ActualValue = new DoubleValue(qualities[bestIndex].Value);
-        BestKnownSolutionParameter.ActualValue = new GQAPAssignment((IntegerVector)assignments[bestIndex].Clone(), (DoubleValue)qualities[bestIndex].Clone(), flowDistanceQualities[bestIndex], installationQualities[bestIndex], overbookedCapacities[bestIndex], equipmentNames, locationNames, distances, weights, installationCosts, demands, capacities, transportationCosts, overbookedCapacityPenalty);
+        BestKnownSolutionParameter.ActualValue = new GQAPAssignment((IntegerVector)assignments[bestIndex].Clone(), (DoubleValue)qualities[bestIndex].Clone(), flowDistanceQualities[bestIndex], installationQualities[bestIndex], overbookedCapacities[bestIndex], equipmentNames, locationNames, distances, weights, installationCosts, demands, capacities, transportationCosts, expectedRandomQuality, evaluator);
       }
 
       var assignment = BestSolutionParameter.ActualValue;
       if (assignment == null) {
-        assignment = new GQAPAssignment((IntegerVector)assignments[bestIndex].Clone(), (DoubleValue)qualities[bestIndex].Clone(), flowDistanceQualities[bestIndex], installationQualities[bestIndex], overbookedCapacities[bestIndex], equipmentNames, locationNames, distances, weights, installationCosts, demands, capacities, transportationCosts, overbookedCapacityPenalty);
+        assignment = new GQAPAssignment((IntegerVector)assignments[bestIndex].Clone(), (DoubleValue)qualities[bestIndex].Clone(), flowDistanceQualities[bestIndex], installationQualities[bestIndex], overbookedCapacities[bestIndex], equipmentNames, locationNames, distances, weights, installationCosts, demands, capacities, transportationCosts, expectedRandomQuality, evaluator);
         assignment.Distances = distances;
         BestSolutionParameter.ActualValue = assignment;
@@ -185,5 +190,6 @@
           assignment.Capacities = capacities;
           assignment.TransportationCosts = transportationCosts;
-          assignment.OverbookedCapacityPenalty = overbookedCapacityPenalty;
+          assignment.ExpectedRandomQuality = expectedRandomQuality;
+          assignment.Evaluator = evaluator;
         }
       }
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Analyzers/GQAPSolutionArchiveAnalyzer.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Analyzers/GQAPSolutionArchiveAnalyzer.cs	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Analyzers/GQAPSolutionArchiveAnalyzer.cs	(revision 7970)
@@ -39,6 +39,6 @@
     IQualitiesAwareGQAPOperator, IDistancesAwareGQAPOperator, IWeightsAwareGQAPOperator, IInstallationCostsAwareGQAPOperator,
     IDemandsAwareGQAPOperator, ICapacitiesAwareGQAPOperator, ITransportationCostsAwareGQAPOperator,
-    IOverbookedCapacityPenaltyAwareGQAPOperator, IEquipmentNamesAwareGQAPOperator, ILocationNamesAwareGQAPOperator,
-    IBestKnownSolutionsAwareGQAPOperator, IAnalyzer {
+    IExpectedRandomQualityAwareGQAPOperator, IEquipmentNamesAwareGQAPOperator, ILocationNamesAwareGQAPOperator,
+    IBestKnownSolutionsAwareGQAPOperator, IEvaluatorAwareGQAPOperator, IAnalyzer {
 
     public bool EnabledByDefault {
@@ -82,6 +82,6 @@
       get { return (IValueLookupParameter<DoubleValue>)Parameters["TransportationCosts"]; }
     }
-    public IValueLookupParameter<DoubleValue> OverbookedCapacityPenaltyParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["OverbookedCapacityPenalty"]; }
+    public IValueLookupParameter<DoubleValue> ExpectedRandomQualityParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["ExpectedRandomQuality"]; }
     }
     public ILookupParameter<StringArray> EquipmentNamesParameter {
@@ -96,4 +96,7 @@
     public ILookupParameter<GQAPAssignmentArchive> BestKnownSolutionsParameter {
       get { return (ILookupParameter<GQAPAssignmentArchive>)Parameters["BestKnownSolutions"]; }
+    }
+    public IValueLookupParameter<IGQAPEvaluator> EvaluatorParameter {
+      get { return (IValueLookupParameter<IGQAPEvaluator>)Parameters["Evaluator"]; }
     }
 
@@ -113,5 +116,5 @@
       Parameters.Add(new LookupParameter<DoubleArray>("Capacities", GeneralizedQuadraticAssignmentProblem.CapacitiesDescription));
       Parameters.Add(new ValueLookupParameter<DoubleValue>("TransportationCosts", GeneralizedQuadraticAssignmentProblem.TransportationCostsDescription));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("OverbookedCapacityPenalty", GeneralizedQuadraticAssignmentProblem.OverbookedCapacityPenaltyDescription));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("ExpectedRandomQuality", GeneralizedQuadraticAssignmentProblem.ExpectedRandomQualityDescription));
       Parameters.Add(new ScopeTreeLookupParameter<IntegerVector>("Assignment", GQAPSolutionCreator.AssignmentDescription));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", GQAPEvaluator.QualityDescription));
@@ -123,7 +126,9 @@
       Parameters.Add(new ValueLookupParameter<ResultCollection>("Results", "The result collection where the best GQAP solution should be stored."));
       Parameters.Add(new LookupParameter<GQAPAssignmentArchive>("BestKnownSolutions", GeneralizedQuadraticAssignmentProblem.BestKnownSolutionsDescription));
+      Parameters.Add(new ValueLookupParameter<IGQAPEvaluator>("Evaluator", "The evaluator that is used to evaluate GQAP solutions."));
     }
 
     public override IOperation Apply() {
+      var evaluator = EvaluatorParameter.ActualValue;
       var assignments = AssignmentParameter.ActualValue;
       var qualities = QualityParameter.ActualValue;
@@ -139,5 +144,5 @@
       var capacities = CapacitiesParameter.ActualValue;
       var transportationCosts = TransportationCostsParameter.ActualValue;
-      var overbookedCapacityPenalty = OverbookedCapacityPenaltyParameter.ActualValue;
+      var expectedRandomQuality = ExpectedRandomQualityParameter.ActualValue;
       var results = ResultsParameter.ActualValue;
       var maximization = MaximizationParameter.ActualValue.Value;
@@ -145,5 +150,5 @@
       GQAPAssignmentArchive archive = results.ContainsKey("Solution Archive") ? results["Solution Archive"].Value as GQAPAssignmentArchive : null;
       if (archive == null) {
-        archive = new GQAPAssignmentArchive(equipmentNames, locationNames, distances, weights, installationCosts, demands, capacities, transportationCosts, overbookedCapacityPenalty);
+        archive = new GQAPAssignmentArchive(equipmentNames, locationNames, distances, weights, installationCosts, demands, capacities, transportationCosts, expectedRandomQuality, evaluator);
         results.Add(new Result("Solution Archive", archive));
       } else {
@@ -156,5 +161,6 @@
         archive.Capacities = capacities;
         archive.TransportationCosts = transportationCosts;
-        archive.OverbookedCapacityPenalty = overbookedCapacityPenalty;
+        archive.ExpectedRandomQuality = expectedRandomQuality;
+        archive.Evaluator = evaluator;
       }
 
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPAdditivePenaltyEvaluator.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPAdditivePenaltyEvaluator.cs	(revision 7970)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPAdditivePenaltyEvaluator.cs	(revision 7970)
@@ -0,0 +1,63 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
+  [Item("GQAPAdditivePenaltyEvaluator", "Evaluates solutions to the generalized quadratic assignment problem using an additive penalty strategy. The overbooked capacities are multiplied by the penalty and added to the quality.")]
+  [StorableClass]
+  public class GQAPAdditivePenaltyEvaluator : GQAPEvaluator {
+    public static readonly string OverbookedCapacityPenaltyDescription = "The multiplier for the constraint violation when added to the quality.";
+
+    protected IValueParameter<DoubleValue> OverbookedCapacityPenaltyParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters["OverbookedCapacityPenalty"]; }
+    }
+
+    public DoubleValue OverbookedCapacity {
+      get { return OverbookedCapacityPenaltyParameter.Value; }
+      set { OverbookedCapacityPenaltyParameter.Value = value; }
+    }
+
+    [StorableConstructor]
+    protected GQAPAdditivePenaltyEvaluator(bool deserializing) : base(deserializing) { }
+    protected GQAPAdditivePenaltyEvaluator(GQAPAdditivePenaltyEvaluator original, Cloner cloner) : base(original, cloner) { }
+    public GQAPAdditivePenaltyEvaluator()
+      : base() {
+      Parameters.Add(new ValueParameter<DoubleValue>("OverbookedCapacityPenalty", OverbookedCapacityPenaltyDescription, new DoubleValue(1000000), true));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new GQAPAdditivePenaltyEvaluator(this, cloner);
+    }
+
+    public override double GetFitness(double flowDistanceQuality,
+      double installationQuality, double overbookedCapacity,
+      double transportationCosts, double expectedRandomQuality) {
+      return installationQuality
+        + transportationCosts * flowDistanceQuality
+        + OverbookedCapacity.Value * overbookedCapacity;
+    }
+  }
+}
Index: branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPEvaluator.cs
===================================================================
--- branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPEvaluator.cs	(revision 7968)
+++ branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Evaluators/GQAPEvaluator.cs	(revision 7970)
@@ -31,9 +31,10 @@
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
-  [Item("GQAPEvaluator", "Evaluates solutions to the generalized quadratic assignment problem.")]
+  [Item("GQAPEvaluator", "Base class for solution evaluators for the generalized quadratic assignment problem.")]
   [StorableClass]
-  public class GQAPEvaluator : SingleSuccessorOperator, IGQAPEvaluator,
+  public abstract class GQAPEvaluator : SingleSuccessorOperator, IGQAPEvaluator,
   IWeightsAwareGQAPOperator, IDistancesAwareGQAPOperator, IInstallationCostsAwareGQAPOperator,
-  IDemandsAwareGQAPOperator, ICapacitiesAwareGQAPOperator, IAssignmentAwareGQAPOperator {
+  IDemandsAwareGQAPOperator, ICapacitiesAwareGQAPOperator, IAssignmentAwareGQAPOperator,
+  IExpectedRandomQualityAwareGQAPOperator {
 
     #region Parameter Descriptions
@@ -62,6 +63,6 @@
       get { return (IValueLookupParameter<DoubleValue>)Parameters["TransportationCosts"]; }
     }
-    public IValueLookupParameter<DoubleValue> OverbookedCapacityPenaltyParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["OverbookedCapacityPenalty"]; }
+    public IValueLookupParameter<DoubleValue> ExpectedRandomQualityParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["ExpectedRandomQuality"]; }
     }
     public ILookupParameter<DoubleMatrix> WeightsParameter {
@@ -87,6 +88,5 @@
     protected GQAPEvaluator(bool deserializing) : base(deserializing) { }
     protected GQAPEvaluator(GQAPEvaluator original, Cloner cloner) : base(original, cloner) { }
-    public GQAPEvaluator()
-      : base() {
+    public GQAPEvaluator() : base() {
       Parameters.Add(new LookupParameter<BoolValue>("Maximization", GeneralizedQuadraticAssignmentProblem.MaximizationDescription));
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", QualityDescription));
@@ -95,5 +95,5 @@
       Parameters.Add(new LookupParameter<DoubleValue>("OverbookedCapacity", OverbookedCapacityDescription));
       Parameters.Add(new ValueLookupParameter<DoubleValue>("TransportationCosts", GeneralizedQuadraticAssignmentProblem.TransportationCostsDescription));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("OverbookedCapacityPenalty", GeneralizedQuadraticAssignmentProblem.OverbookedCapacityPenaltyDescription));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("ExpectedRandomQuality", GeneralizedQuadraticAssignmentProblem.ExpectedRandomQualityDescription));
       Parameters.Add(new LookupParameter<DoubleMatrix>("Weights", GeneralizedQuadraticAssignmentProblem.WeightsDescription));
       Parameters.Add(new LookupParameter<DoubleMatrix>("Distances", GeneralizedQuadraticAssignmentProblem.DistancesDescription));
@@ -104,21 +104,18 @@
     }
 
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new GQAPEvaluator(this, cloner);
-    }
-
-    public static double Evaluate(IntegerVector assignment, DoubleMatrix weights, DoubleMatrix distances,
-                                  DoubleMatrix installCosts, DoubleArray demands, DoubleArray capacities,
-                                  DoubleValue transportationCosts, DoubleValue overbookedCapacityPenalty) {
+    public virtual double Evaluate(IntegerVector assignment, DoubleMatrix weights,
+      DoubleMatrix distances, DoubleMatrix installCosts, DoubleArray demands,
+      DoubleArray capacities, double transportationCosts, double expectedRandomQuality) {
       double flowDistanceQuality, installationQuality, overbookedCapacity;
       Evaluate(assignment, weights, distances, installCosts, demands, capacities,
         out flowDistanceQuality, out installationQuality, out overbookedCapacity);
-      return GetCombinedQuality(flowDistanceQuality, installationQuality, overbookedCapacity,
-        transportationCosts.Value, overbookedCapacityPenalty.Value);
+      return GetFitness(flowDistanceQuality, installationQuality, overbookedCapacity,
+        transportationCosts, expectedRandomQuality);
     }
 
-    public static void Evaluate(IntegerVector assignment, DoubleMatrix weights, DoubleMatrix distances,
-                                DoubleMatrix installCosts, DoubleArray demands, DoubleArray capacities,
-                                out double flowDistanceQuality, out double installationQuality, out double overbookedCapacity) {
+    public virtual void Evaluate(IntegerVector assignment, DoubleMatrix weights, DoubleMatrix distances,
+      DoubleMatrix installCosts, DoubleArray demands, DoubleArray capacities,
+      out double flowDistanceQuality, out double installationQuality,
+      out double overbookedCapacity) {
       flowDistanceQuality = 0;
       installationQuality = 0;
@@ -135,14 +132,11 @@
     }
 
-    public static double EvaluateOverbooking(DoubleArray slack, DoubleArray capacities) {
-      return slack.Select((v, i) => new { V = v, Index = i }).Where(x => x.V < 0.0).Select(x => -x.V / capacities[x.Index]).Sum();
+    public virtual double EvaluateOverbooking(DoubleArray slack, DoubleArray capacities) {
+      return slack.Select((v, i) => new { V = v, Index = i }).Where(x => x.V < 0.0).Select(x => -100.0 * x.V / capacities[x.Index]).Sum();
     }
 
-    public static double GetCombinedQuality(double flowDistanceQuality, double installationQuality, double overbookedCapacity,
-      double transportationCosts, double overbookedCapacityPenalty) {
-      return installationQuality
-        + transportationCosts * flowDistanceQuality
-        + overbookedCapacityPenalty * overbookedCapacity;
-    }
+    public abstract double GetFitness(double flowDistanceQuality,
+      double installationQuality, double overbookedCapacity,
+      double transportationCosts, double expectedRandomQuality);
 
     public override IOperation Apply() {
@@ -154,5 +148,5 @@
       var capacities = CapacitiesParameter.ActualValue;
       var transportCosts = TransportationCostsParameter.ActualValue.Value;
-      double penalty = OverbookedCapacityPenaltyParameter.ActualValue.Value;
+      var expectedRandomQuality = ExpectedRandomQualityParameter.ActualValue.Value;
 
       if (weights.Rows != weights.Columns || distances.Rows != distances.Columns
@@ -169,5 +163,5 @@
       OverbookedCapacityParameter.ActualValue = new DoubleValue(overbookedCapacity);
 
-      QualityParameter.ActualValue = new DoubleValue(GetCombinedQuality(flowDistanceQuality, installationQuality, overbookedCapacity, transportCosts, penalty));
+      QualityParameter.ActualValue = new DoubleValue(GetFitness(flowDistanceQuality, installationQuality, overbookedCapacity, transportCosts, expectedRandomQuality));
       return base.Apply();
     }
